

SUBROUTINE Var(m, arpno, IBDSn, Empvar, Mean)
  IMPLICIT NONE
  integer, parameter   :: DP = selected_real_kind(33)
  INTEGER, INTENT(IN)  :: m, arpno
  REAL(KIND=DP), INTENT(IN)     :: IBDSn(m,arpno)
  REAL(KIND=DP), INTENT(OUT)    :: Mean(m), Empvar(m,m)
  REAL(KIND=DP)        :: RES2(m,arpno), temp
  INTEGER              :: i, k


  DO k=1, m
    Mean(k)=REAL(SUM(IBDSn(k,1:arpno)))/REAL(arpno)
  END DO


  DO i=1, arpno
    DO k=1, m
      RES2(k,i)=(REAL(IBDSn(k,i))-Mean(k))**2
    END DO
  END DO


  Empvar=0.0_dp

  DO k=1, m
    temp=0.0_dp
    DO i=1, arpno
      temp=temp+RES2(k,i)
    END DO
    Empvar(k,k)=temp/(REAL(arpno)-1.0_dp)
  END DO


END SUBROUTINE Var


 
